/***************************************************************
 * Name:      Mon_Arbo.cpp
 * Purpose:   Code for GenericDirCtrl
 * Author:    Jackie Team (jackie.team@gmail.com)
 * Created:   2007-11-26
 * Copyright: Jackie Team (http://musicorganizer.free.fr)
 * License: GNU GPL
 **************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#ifdef __BORLANDC__
#pragma hdrstop
#endif //__BORLANDC__

#include "components.h"

IMPLEMENT_DYNAMIC_CLASS(MonArbo, wxGenericDirCtrl)

BEGIN_EVENT_TABLE(MonArbo, wxGenericDirCtrl)
    EVT_TREE_SEL_CHANGED(wxID_ANY,MonArbo::change)
    EVT_MENU(THREAD,MonArbo::endChange)
END_EVENT_TABLE()

MonArbo::MonArbo(wxWindow* parent,MaListe* l, MonBook* b) : wxGenericDirCtrl(parent, wxID_ANY,_T(""),wxPoint(0,0),wxDefaultSize,wxDIRCTRL_DIR_ONLY|wxDIRCTRL_EDIT_LABELS)
{
    liste=l;
    book=b;
    wait=new WaitPopup(this);
    ignore_event=false;
    OptionsHandler::readOptions();
    wxString savedPath=OptionsHandler::getOption(_T("path"));
    //we reload the directory if wanted
    if(wxDirExists(savedPath) && OptionsHandler::getOption(_T("save_dir"))==_T("1")){
        setIgnore(true);
        SetPath(savedPath);
        setIgnore(false);
    }
}

void MonArbo::setIgnore(bool b){
   ignore_event=b;
}

void MonArbo::change(wxTreeEvent& e){
    if(ignore_event==true)
        return;
    //Saving the path
    OptionsHandler::setOption(_T("path"),GetPath());
    OptionsHandler::writeOptions();

    //wxSortedArrayString files;
    book->getComboTitre()->Clear();
    book->getComboInterprete()->Clear();
    book->getComboAlbum()->Clear();
    book->getComboPiste()->Clear();
    //-------------Listes de rajouts pour les combobox
    book->getLstComboTitre()->Empty();
    book->getLstComboInterprete()->Empty();
    book->getLstComboAlbum()->Empty();
    book->getLstComboPiste()->Empty();
    //---------------

    book->getComboAlbum()->SetValue(_T(""));
    book->getComboTitre()->SetValue(_T(""));
    book->getComboInterprete()->SetValue(_T(""));
    book->getComboAnne()->SetValue(_T(""));
    book->getComboGenre()->SetValue(_T(""));
    book->getComboPiste()->SetValue(_T(""));
    book->getComboAlbum2()->SetValue(_T(""));
    book->getComboTitre2()->SetValue(_T(""));
    book->getComboInterprete2()->SetValue(_T(""));
    book->getComboAnne2()->SetValue(_T(""));
    book->getComboGenre2()->SetValue(_T(""));
    book->getComboPiste2()->SetValue(_T(""));
    liste->getTitreV1()->clear();
    liste->getArtisteV1()->clear();
    liste->getAlbumV1()->clear();
    liste->getAnneeV1()->clear();
    liste->getGenreV1()->clear();
    liste->getPisteV1()->clear();
    liste->getTitreV1Sorted()->clear();
    liste->getArtisteV1Sorted()->clear();
    liste->getAlbumV1Sorted()->clear();
    liste->getAnneeV1Sorted()->clear();
    liste->getGenreV1Sorted()->clear();
    liste->getPisteV1Sorted()->clear();
    liste->removeColumnImage();
    for(int i=0 ; i<9 ; i++)
       liste->itemDataMap[i].clear();

    wxString path;
    path=GetPath();

    std::string chemin((char const*)path.mb_str(*wxConvCurrent));
    wait->Centre();
    wait->Show();
    files.clear();
    Disable();
    if (chemin.size()==3 and chemin.substr(1,3)==":\\" or chemin=="/")
        t=new ScanThread(this,chemin,&files,false); //nous sommes dans un répértoire racine
    else
        t=new ScanThread(this,chemin,&files);
    t->Create();
    t->Run();

    //walkThrough(chemin,files);
}

void MonArbo::endChange(wxCommandEvent& event){
    bool arreter=false;
    wait->Hide();
    std::sort( files.begin(), files.end() );
    liste->DeleteAllItems();
    wxProgressDialog* progBar=new wxProgressDialog(_("Please wait"),_("Informations reading..."),100,NULL,wxPD_AUTO_HIDE | wxPD_APP_MODAL | wxPD_CAN_ABORT | wxPD_SMOOTH);
    liste->clearCurrent();
    for (unsigned int i=0 ; i<files.size() ; i++){
        std::string file=files[i];
        arreter=!progBar->Update((i*1.0)/files.size()*100,_T(""));
        if(arreter==true)
            break;
        liste->addToCurrent(file);
        liste->readAndShowInfos(file,i);
    }
    if(files.size()==0)
         liste->sendMenuMsg(-1);
    else
         liste->sendMenuMsg(2);
    progBar->Destroy();
    Enable();

}

void MonArbo::refresh(){
        wxString path;
        setIgnore(true);
        path=GetPath();
        CollapseTree();
        #ifdef __WXMSW__
        SetPath(path);
        #endif
        setIgnore(false);
        SetPath(path);
}

void MonArbo::stopThread(){
    t->Stop();
}
