/***************************************************************************
 *   Copyright (C) 2007 by Jackie Team   *
 *   jackie.team@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Options_Handler.h"

wxString OptionsHandler::fileName;
wxXmlDocument* OptionsHandler::optionsFile;
std::map<wxString,wxString> OptionsHandler::options;

bool OptionsHandler::loadFile(wxString name){
    fileName=name;
    optionsFile=new wxXmlDocument();
    options.clear();
    wxLogNull nolog;
    return optionsFile->Load(fileName);
}

wxString OptionsHandler::getOption(wxString o){
    std::map<wxString,wxString>::const_iterator mit(options.find(o));
    if(mit!=options.end())
         return mit->second;
    else
         return _T("");
}

void OptionsHandler::setOption(wxString op,wxString val){
    options[op]=val;
}


void OptionsHandler::readOptions(){
    if(optionsFile!=NULL && optionsFile->IsOk()){
        wxXmlNode *child ;
        for(child= optionsFile->GetRoot()->GetChildren(); child != NULL; child = child->GetNext()){
            wxString name=child->GetPropVal(_T("name"),_T(""));
            if(child->GetChildren()!=NULL){
                wxString val=child->GetChildren()->GetContent();
                if(name!=_T(""))
                   options[name]=val;
            }

       }

    }

}

void OptionsHandler::writeOptions(wxString name){
    std::map<wxString, wxString>::iterator it;
    if(optionsFile==NULL || !optionsFile->IsOk()){
        optionsFile=new wxXmlDocument();
    }else{
        //efface l'arborescence du fichier
        wxXmlNode* r=optionsFile->DetachRoot();
        if(r!=NULL)
           delete r;
    }
    wxXmlNode* root= new wxXmlNode(NULL,wxXML_ELEMENT_NODE,_T("options"));
    wxXmlNode* last=NULL;
    for ( it=options.begin(); it != options.end(); it++ ){
          wxXmlNode* option = new wxXmlNode(root, wxXML_ELEMENT_NODE,_T("option"));
          wxXmlNode* val = new wxXmlNode(option, wxXML_TEXT_NODE,_T("option2"),it->second);
          if(last!=NULL)
              option->SetNext(last);
          else
              root->AddChild(option);
          option->AddProperty(_T("name"),it->first);
          option->AddChild(val);
          last=option;
     }
     optionsFile->SetRoot(root);
     optionsFile->Save(name);

}
